=== debian/changelog ===
primecount (7.14+ds-1) unstable; urgency=medium

  * New upstream minor release.

 -- Jerome Benoit <calculus@rezozer.net>  Mon, 02 Sep 2024 16:58:16 +0000
