## primecount 7.15+ds

=== debian/changelog ===
primecount (7.15+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/{copyright,adhoc/{c,cpp}/Makefile, copyright year-tuples, refrech;
    - d/control:
      - Standards-Version, bump to 4.7.2 (no change).

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 09 Mar 2025 15:23:48 +0000
