## primecount 7.16%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.4...3.27)
 project(primecount CXX)
 set(PRIMECOUNT_VERSION_MAJOR 7)
-set(PRIMECOUNT_VERSION_MINOR 14)
+set(PRIMECOUNT_VERSION_MINOR 16)
 set(PRIMECOUNT_VERSION "${PRIMECOUNT_VERSION_MAJOR}.${PRIMECOUNT_VERSION_MINOR}")
 
 # Build options ######################################################
@@ -162,11 +162,18 @@
     include("${PROJECT_SOURCE_DIR}/cmake/multiarch_avx512_vpopcnt.cmake")
 
     if(multiarch_x86_popcnt OR multiarch_avx512_vpopcnt)
-        set(LIB_SRC ${LIB_SRC} src/x86/cpuid.cpp)
-    endif()
-
-    if(NOT multiarch_avx512_vpopcnt)
+        set(LIB_SRC ${LIB_SRC} src/arch/x86/cpuid.cpp)
+        if (multiarch_avx512_vpopcnt)
+            set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_hard_multiarch_avx512.cpp)
+            set(LIB_SRC ${LIB_SRC} src/gourdon/D_multiarch_avx512.cpp)
+        endif()
+    else()
         include("${PROJECT_SOURCE_DIR}/cmake/multiarch_arm_sve.cmake")
+        if(multiarch_arm_sve)
+            set(LIB_SRC ${LIB_SRC} src/arch/arm/sve.cpp)
+            set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_hard_multiarch_arm_sve.cpp)
+            set(LIB_SRC ${LIB_SRC} src/gourdon/D_multiarch_arm_sve.cpp)
+        endif()
     endif()
 endif()
 
@@ -306,13 +313,3 @@
 if(STATICALLY_LINK_LIBPRIMECOUNT)
     add_library(primecount::primecount ALIAS libprimecount-static)
 else()
-    add_library(primecount::primecount ALIAS libprimecount)
-endif()
-
-# primecount binary ##################################################
-
-if(BUILD_PRIMECOUNT)
-    add_executable(primecount ${BIN_SRC})
-    target_link_libraries(primecount PRIVATE primecount::primecount primesieve::primesieve)
-    target_compile_definitions(primecount PRIVATE ${PRIMECOUNT_COMPILE_DEFINITIONS})
-    target_compile_features(primecount PRIVATE cxx_auto_type)
