=== debian/changelog ===
primecount (7.16+ds-1) unstable; urgency=medium

  * New upstream minor release.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 06 Apr 2025 17:16:53 +0000
