## primecount 7.19%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.4...3.27)
 project(primecount CXX)
 set(PRIMECOUNT_VERSION_MAJOR 7)
-set(PRIMECOUNT_VERSION_MINOR 16)
+set(PRIMECOUNT_VERSION_MINOR 19)
 set(PRIMECOUNT_VERSION "${PRIMECOUNT_VERSION_MAJOR}.${PRIMECOUNT_VERSION_MINOR}")
 
 # Build options ######################################################
@@ -53,28 +53,6 @@
 
 if(NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
     message(FATAL_ERROR "One or both of BUILD_SHARED_LIBS or BUILD_STATIC_LIBS must be set to ON!")
-endif()
-
-# Static vs. shared linking ##########################################
-
-# By default libprimecount is linked statically if only the static
-# libprimecount has been built. If libprimecount has been built as
-# both a static and shared library then the shared libprimecount will
-# be used for linking.
-
-# It is possible to force static linking by setting:
-# cmake -DSTATICALLY_LINK_LIBPRIMECOUNT=ON
-# This way libprimecount will be linked statically even if
-# libprimecount has been built as both a static and shared library.
-
-if(NOT STATICALLY_LINK_LIBPRIMECOUNT)
-    if(BUILD_STATIC_LIBS AND NOT BUILD_SHARED_LIBS)
-        set(STATICALLY_LINK_LIBPRIMECOUNT TRUE)
-    endif()
-endif()
-
-if(STATICALLY_LINK_LIBPRIMECOUNT AND NOT BUILD_STATIC_LIBS)
-    message(FATAL_ERROR "Using STATICALLY_LINK_LIBPRIMECOUNT=ON requires BUILD_STATIC_LIBS=ON!")
 endif()
 
 # Set default build type to Release ##################################
@@ -220,6 +198,7 @@
 # Required includes ##################################################
 
 include(GNUInstallDirs)
+include(CMakePackageConfigHelpers)
 
 # libprimesieve ######################################################
 
@@ -269,11 +248,15 @@
         cxx_lambdas
         cxx_range_for)
 
-    target_include_directories(libprimecount PUBLIC
+    target_include_directories(libprimecount
+    PUBLIC
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
-        $<INSTALL_INTERFACE:include>)
+        $<INSTALL_INTERFACE:include>
+    PRIVATE
+        ${CMAKE_CURRENT_SOURCE_DIR}/src)
 
     install(TARGETS libprimecount
+            EXPORT primecountShared
             RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
             LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
             ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
@@ -298,11 +281,15 @@
         cxx_lambdas
         cxx_range_for)
 
-    target_include_directories(libprimecount-static PUBLIC
+    target_include_directories(libprimecount-static
+    PUBLIC
         $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
-        $<INSTALL_INTERFACE:include>)
+        $<INSTALL_INTERFACE:include>
+    PRIVATE
+        ${CMAKE_CURRENT_SOURCE_DIR}/src)
 
     install(TARGETS libprimecount-static
+            EXPORT primecountStatic
             RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
             LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
             ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
@@ -310,6 +297,22 @@
 
 # Shared vs. static linking ##########################################
 
+# On Unix-like OSes we use shared linking against libprimecount by
+# default mainly because this is required by Linux distributions.
+# On Windows we use static linking by default because the library's
+# path is not encoded into the binary. This means that the binary
+# will only work if the DLL is in the same directory or a directory
+# that is in the PATH environment variable.
+
+if(WIN32 AND TARGET libprimecount-static)
+    set(STATICALLY_LINK_LIBPRIMECOUNT ON)
+elseif(NOT TARGET libprimecount)
+    set(STATICALLY_LINK_LIBPRIMECOUNT ON)
+endif()
+
 if(STATICALLY_LINK_LIBPRIMECOUNT)
     add_library(primecount::primecount ALIAS libprimecount-static)
 else()
+    add_library(primecount::primecount ALIAS libprimecount)
+endif()
+
