=== debian/tests/control ===
Test-Command: primecount --test

Tests: make-check-bin
Depends: primecount-bin

Tests: build-examples
Depends: primecount-doc, libprimecount-dev, build-essential, pkgconf

Tests: make-check-dev
Depends: libprimecount-dev, build-essential, pkgconf
Restrictions: allow-stderr
