=== debian/changelog ===
primecount (7.19+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 17 Aug 2025 15:44:52 +0000

primecount (7.19+ds-1) experimental; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/tests/*:
      - d/t/make-check-dev, refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 07 Jun 2025 23:43:16 +0000

primecount (7.18+ds-1) experimental; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/tests/*:
      - d/t/control, reorder tests;
      - d/t/make-check-dev, refresh and harden.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 18 May 2025 15:16:43 +0000

primecount (7.17+ds-1) experimental; urgency=medium

  * New upstream minor release.

 -- Jerome Benoit <calculus@rezozer.net>  Sat, 10 May 2025 17:40:43 +0000
