## primecount 7.20+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.4...3.27)
 project(primecount CXX)
 set(PRIMECOUNT_VERSION_MAJOR 7)
-set(PRIMECOUNT_VERSION_MINOR 19)
+set(PRIMECOUNT_VERSION_MINOR 20)
 set(PRIMECOUNT_VERSION "${PRIMECOUNT_VERSION_MAJOR}.${PRIMECOUNT_VERSION_MINOR}")
 
 # Build options ######################################################
@@ -46,8 +46,11 @@
 # Option sanity checks ###############################################
 
 # We don't yet support building libprimecount as a shared DLL
-# library on Windows. If you need this let me know...
-if(WIN32)
+# library on Windows using the MSVC compiler. The MSVC compiler
+# by default does not allow accessing global variables that
+# are inside a DLL, unless all those variables are annotated
+# using __declspec(dllexport) and __declspec(dllimport).
+if(WIN32 AND NOT MINGW)
     set(BUILD_SHARED_LIBS OFF)
 endif()
 
@@ -310,9 +313,3 @@
     set(STATICALLY_LINK_LIBPRIMECOUNT ON)
 endif()
 
-if(STATICALLY_LINK_LIBPRIMECOUNT)
-    add_library(primecount::primecount ALIAS libprimecount-static)
-else()
-    add_library(primecount::primecount ALIAS libprimecount)
-endif()
-
