=== debian/changelog ===
primecount (7.20+ds-1) unstable; urgency=medium

  * New upstream minor release.
  * Debianization:
    - d/copyright:
      - Files-Excluded list, refresh;
      - debian/adhoc/lintian/privacy-breach/www/images/* entry, obsoleted;
    - d/patches/*:
      - d/p/debianization-documentation.patch, obsoleted;
    - d/adhoc/lintian/privacy-breach/*, obsoleted;
    - d/primecount-doc.links, refresh;
    - d/primecount-doc.docs, update;
    - d/control:
      - Rules-Requires-Root field, now rely on default.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 16 Nov 2025 19:32:04 +0000
