=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Uploaders: Jerome Benoit <calculus@rezozer.net>
 Section: math
 Priority: optional
-Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (=13),
  cmake,
