## primecount 8.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
-cmake_minimum_required(VERSION 3.4...3.27)
+cmake_minimum_required(VERSION 3.9...3.30)
 project(primecount CXX)
-set(PRIMECOUNT_VERSION_MAJOR 7)
-set(PRIMECOUNT_VERSION_MINOR 20)
+set(PRIMECOUNT_VERSION_MAJOR 8)
+set(PRIMECOUNT_VERSION_MINOR 0)
 set(PRIMECOUNT_VERSION "${PRIMECOUNT_VERSION_MAJOR}.${PRIMECOUNT_VERSION_MINOR}")
 
 # Build options ######################################################
@@ -18,7 +18,14 @@
 option(WITH_DIV32           "Use 32-bit division instead of 64-bit division whenever possible" OFF)
 option(WITH_MSVC_CRT_STATIC "Link primecount.lib with /MT instead of the default /MD" OFF)
 option(WITH_FLOAT128        "Use __float128 (requires libquadmath), increases precision of Li(x) & RiemannR" OFF)
-option(WITH_JEMALLOC        "Use jemalloc allocator"               OFF)
+
+# Check if primecount is top level project ###########################
+
+if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
+    set(PRIMECOUNT_IS_TOP_PROJECT ON)
+else()
+    set(PRIMECOUNT_IS_TOP_PROJECT OFF)
+endif()
 
 # Enable/Disable libdivide ###########################################
 
@@ -60,19 +67,29 @@
 
 # Set default build type to Release ##################################
 
-if(NOT CMAKE_VERSION VERSION_LESS 3.9)
+if(PRIMECOUNT_IS_TOP_PROJECT)
     get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
-elseif(CMAKE_CONFIGURATION_TYPES)
-    set(isMultiConfig TRUE)
-endif()
-
-if(NOT isMultiConfig AND NOT CMAKE_BUILD_TYPE)
-    set(CMAKE_BUILD_TYPE Release CACHE STRING
-    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
+
+    if(NOT isMultiConfig AND NOT CMAKE_BUILD_TYPE)
+        message(STATUS "Setting CMAKE_BUILD_TYPE = Release")
+        set(CMAKE_BUILD_TYPE Release CACHE STRING
+            "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
+    endif()
 endif()
 
 if(CMAKE_BUILD_TYPE STREQUAL "Debug")
     list(APPEND PRIMECOUNT_COMPILE_DEFINITIONS "ENABLE_ASSERT")
+endif()
+
+# Hide symbols of inline functions ###################################
+# This reduces the size of the shared libprimecount by about 1%.
+
+if(PRIMECOUNT_IS_TOP_PROJECT)
+    if (NOT DEFINED CMAKE_VISIBILITY_INLINES_HIDDEN)
+        message(STATUS "Setting CMAKE_VISIBILITY_INLINES_HIDDEN = ON")
+        set(CMAKE_VISIBILITY_INLINES_HIDDEN ON CACHE BOOL
+            "Whether to add a compiler flag to hide symbols of inline functions")
+    endif ()
 endif()
 
 # primecount binary source files #####################################
@@ -115,11 +132,13 @@
             src/lmo/pi_lmo4.cpp
             src/lmo/pi_lmo5.cpp
             src/lmo/pi_lmo_parallel.cpp
+            src/deleglise-rivat/S2_easy.cpp
             src/deleglise-rivat/S2_hard.cpp
             src/deleglise-rivat/S2_trivial.cpp
             src/deleglise-rivat/pi_deleglise_rivat.cpp
             src/gourdon/pi_gourdon.cpp
             src/gourdon/Phi0.cpp
+            src/gourdon/AC.cpp
             src/gourdon/B.cpp
             src/gourdon/D.cpp
             src/gourdon/LoadBalancerAC.cpp
@@ -129,11 +148,7 @@
 # Use libdivide.h (fast integer divison) #############################
 
 if(WITH_LIBDIVIDE)
-    set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_easy_libdivide.cpp)
-    set(LIB_SRC ${LIB_SRC} src/gourdon/AC_libdivide.cpp)
-else()
-    set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_easy.cpp)
-    set(LIB_SRC ${LIB_SRC} src/gourdon/AC.cpp)
+    list(APPEND PRIMECOUNT_COMPILE_DEFINITIONS "ENABLE_LIBDIVIDE")
 endif()
 
 # Check if compiler supports CPU multiarch ###########################
@@ -144,16 +159,10 @@
 
     if(multiarch_x86_popcnt OR multiarch_avx512_vpopcnt)
         set(LIB_SRC ${LIB_SRC} src/arch/x86/cpuid.cpp)
-        if (multiarch_avx512_vpopcnt)
-            set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_hard_multiarch_avx512.cpp)
-            set(LIB_SRC ${LIB_SRC} src/gourdon/D_multiarch_avx512.cpp)
-        endif()
     else()
         include("${PROJECT_SOURCE_DIR}/cmake/multiarch_arm_sve.cmake")
         if(multiarch_arm_sve)
             set(LIB_SRC ${LIB_SRC} src/arch/arm/sve.cpp)
-            set(LIB_SRC ${LIB_SRC} src/deleglise-rivat/S2_hard_multiarch_arm_sve.cpp)
-            set(LIB_SRC ${LIB_SRC} src/gourdon/D_multiarch_arm_sve.cpp)
         endif()
     endif()
 endif()
@@ -307,9 +316,3 @@
 # will only work if the DLL is in the same directory or a directory
 # that is in the PATH environment variable.
 
-if(WIN32 AND TARGET libprimecount-static)
-    set(STATICALLY_LINK_LIBPRIMECOUNT ON)
-elseif(NOT TARGET libprimecount)
-    set(STATICALLY_LINK_LIBPRIMECOUNT ON)
-endif()
-
