=== debian/changelog ===
primecount (8.0+ds-1) unstable; urgency=medium

  * New upstream major release.
  * Debianization:
    - SONAME, bump from 7 to 8.

 -- Jerome Benoit <calculus@rezozer.net>  Fri, 26 Dec 2025 16:53:53 +0000
