=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends:
  debhelper-compat (=13),
  cmake,
- libprimesieve-dev (>=8.0),
+ libprimesieve-dev,
  asciidoc-base, xmlto
 Build-Depends-Indep:
 	pandoc
@@ -28,7 +28,7 @@
  .
  This dummy package provides the standard installation.
 
-Package: libprimecount7
+Package: libprimecount8
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -51,7 +51,7 @@
 Multi-Arch: same
 Section: libdevel
 Depends:
- libprimecount7 (= ${binary:Version}), libprimecount-dev-common (= ${source:Version}),
+ libprimecount8 (= ${binary:Version}), libprimecount-dev-common (= ${source:Version}),
  libprimesieve-dev,
  ${misc:Depends}
 Suggests: primecount-doc (= ${source:Version}), pkgconf
@@ -70,8 +70,8 @@
 Package: libprimecount-dev-common
 Architecture: all
 Multi-Arch: foreign
-Replaces: libprimecount7-dev-common
-Breaks: libprimecount7-dev-common
+Replaces: libprimecount8-dev-common
+Breaks: libprimecount8-dev-common
 Section: libdevel
 Depends: ${misc:Depends}
 Recommends: libprimecount-dev (= ${binary:Version})
