=== debian/changelog ===
primecount (8.1+ds-1) unstable; urgency=medium

  * New upstream version.
  * Debianization:
    - d/{copyright,adhoc/{c,cpp}/Makefile, copyright year-tuples, refrech;
    - d/control:
      - Priority field, now rely on the default;
      - Standards-Version, bump to 4.7.3 (no change);
    - d/tests/*:
      - d/t/make-check-dev, refresh.

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 01 Feb 2026 14:10:08 +0000
