=== debian/rules ===
--- 
+++ 
@@ -46,7 +46,7 @@
 override_dh_prep-arch: README.toc.md
 
 override_dh_installdocs:
-	dh_installdocs -pprimecount-bin    --link-doc=libprimecount7
+	dh_installdocs -pprimecount-bin    --link-doc=libprimecount8
 	dh_installdocs -plibprimecount-dev --doc-main-package=libprimecount-dev-common
 	dh_installdocs --remaining-packages
