=== debian/changelog ===
primecount (8.2+ds-1) unstable; urgency=medium

  * New upstream version (Closes: #1128056).

 -- Jerome Benoit <calculus@rezozer.net>  Sun, 01 Mar 2026 18:22:06 +0000
